$DEBUG OJ(OSDDRV.OBJ)

NAME	OSDDRV

USING 0

%out(Enter the CODE of OSD part (6454 or 6458) (default 6458) ? )
%define(OSDPartStr)(%in)
%if (%len(%OSDPartStr) EQ 2) then (
  %set(OSDPart,6458)
) else (
  %set(OSDPart,%OSDPartStr)
  %if ( (%OSDPart NE 6458) AND (%OSDPart NE 6454) )
  then (
    %out(*** WARNING #1000, define OSDPart bad(%OSDPart), set to default state.
    )
    %set(OSDPart,6458)
  ) fi
) fi

%out(Enter the name of OSD pins definition file (default OSD.PIN) ? )
%define(OSD_pins)(%in)
%if (%len(%OSD_pins) EQ 2) then (
$INCLUDE(OSD.PIN)
) else (
$INCLUDE(%substr(%OSD_pins,1,%len(%OSD_pins)-2))
) fi

true	EQU	1
false	EQU	0
;******************************************************************************
;******************************************************************************
;C-language procedure prototypes
;void InitOSD();
;void ClearOSD();
;void StartOSD();
;void StopOSD();
;void OSDOn();
;void OSDOff();
;void OSDBlink(byte BlinkRate);
;void SelBkgrColor(byte bgColor);
;void SelBkgrType(byte bgType);
;void BackGroundHalfTone(bit HalfTone)
;void SelIntVideoMode(bit IntVideo);
;void SelTVNorm(bit PAL)
;void SetOSDPosition(byte X, byte Y);
;void SetRAMAddress(byte Column, byte Row);
;void DispOSDChar(byte Char, byte BlinkAttr);
;void DispUnxlatedOSDChar(byte Char, byte BlinkAttr);
;void DispOSDString(byte BlinkAttr, char * String);
;byte DispOSDLine(word ColumnAndRow,byte SizeAndBlinkAttr,char * String);

PUBLIC InitOSD, ClearOSD, StartOSD, StopOSD, OSDOn, OSDOff, _OSDBlink
PUBLIC _SelBkgrColor,_SelBkgrType, BackGroundHalfTone, SelIntVideoMode
PUBLIC _SetOSDPosition,_SetRAMAddress,_DispOSDChar,_DispOSDLine,_DispOSDString
PUBLIC _DispUnxlatedOSDChar

bgColorBlack	EQU	00100000b
bgColorBlue		EQU	00100010b
bgColorGreen	EQU	00100100b
bgColorCyan		EQU	00100110b
bgColorRed		EQU	00101000b
bgColorMagenta	EQU	00101010b
bgColorYellow	EQU	00101100b
bgColorWhite	EQU	00101110b

bgTypeNone		EQU	00110000b
bgTypeFringed	EQU	00110010b
bgTypeSquare	EQU	00110100b
bgTypeSolid		EQU	00110110b

atCharBlink		EQU	10000000b
atCharSizeLow	EQU	00000000b
atCharSizeMedLo	EQU	00000001b
atCharSizeMedHi	EQU	00000010b
atCharSizeHigh	EQU	00000011b

PUBLIC bgColorBlue,  bgColorGreen,  bgColorCyan, bgColorRed, bgColorMagenta
PUBLIC bgColorBlack, bgColorYellow, bgColorWhite
PUBLIC bgTypeNone, bgTypeFringed, bgTypeSquare, bgTypeSolid
PUBLIC atCharBlink,atCharSizeLow,atCharSizeMedLo,atCharSizeMedHi,atCharSizeHigh

cmVideoRAMBatchClear		EQU	00000000b
cmTVNormPAL					EQU	01001001b
cmScanModeInterlace			EQU	01010001b
cmSyncDetON					EQU	01011100b
InitOSDControl				EQU	00010000b
InitInternalVideoBkgrColor	EQU	bgColorBlue
InitBkgrType				EQU	bgTypeFringed
InitHalfTone				EQU	true
InitExtVideoMode			EQU	false

InitOSDPosition					EQU	1000000010000110b ;Y=4x9lines, X=6 dots
;InitChar_BkgrLuminanceLevel	EQU	1001000100001000b
								;VPD=2Vpp amplitude, bkgr luminance=0, char=max
InitChar_BkgrLuminanceLevel		EQU	1001000000001000b
								;VPD=1Vpp amplitude, bkgr luminance=0, char=max

;******************************************************************************
EXTRN CODE(_TIME, ?C_CLDOPTR)

OSD_CODE	SEGMENT	CODE INBLOCK
OSD_DATA	SEGMENT	DATA
OSD_BIT		SEGMENT	BIT

RSEG OSD_DATA
OSDControl:				DS	1
InternalVideoBkgrColor:	DS	1
BkgrType:				DS	1
OSDPosition:			DS	2
RAMAddress:				DS	2

RSEG OSD_BIT
?BackGroundHalfTone?BIT:	DBIT	1
?SelIntVideoMode?BIT:		DBIT	1
IntVideoMode				BIT		?SelIntVideoMode?BIT

PUBLIC ?BackGroundHalfTone?BIT, ?SelIntVideoMode?BIT, IntVideoMode, OSDControl

RSEG OSD_CODE
;******************************************************************************
SEND_BYTE:
		MOV	R4,#8
SEND_BIT:
		RLC		A
		MOV		SDATA,C				;Data SetUp is only 0.25us (Tsudat)
		NOP							;Delay for safe recognoscation of START
		SJMP	$+2					;by slave processor in decoder part.
		SJMP	$+2					;This procesor will test every change
		SJMP	$+2					;on SDA line for START condition (SCL=1).
		SJMP	$+2					;Because the speed of both processors
		SJMP	$+2					;are the same, we must wait after SDA
		SJMP	$+2					;change, until the decoder processor
		SJMP	$+2					;detects, that no START occurs.
		SJMP	$+2
		SJMP	$+2
		SETB	SCLK				;SCLK high time 4us (Thigh)
		SJMP	$+2
		SJMP	$+2
		SJMP	$+2
		SJMP	$+2					;Thigh=4us
		SJMP	$+2
		CLR		SCLK				;Data may change without hold time
		DJNZ	R4,SEND_BIT			;(Thddat=0us), SCLK is held low by
									;Tlow=5us while new data are set
		RET
;******************************************************************************
_SEND_BYTE:
		clr		sclk
		clr		sdata				;Don't generate I2C START condition
		clr		enable
		mov		a,r7
		call	send_byte
		setb	enable
		setb	sdata
		setb	sclk				;Don't generate I2C STOP condition
		RET
;******************************************************************************
_SEND_WORD:
		clr		sclk
		clr		sdata				;Don't generate I2C START condition
		clr		enable
		mov		a,r6
		call	send_byte
		mov		a,r7
		call	send_byte
		setb	enable
		setb	sdata
		setb	sclk				;Don't generate I2C STOP condition
		RET
;******************************************************************************
;NAME: InitOSD
;
;ABSTRACT: Clears OSD, sets OSD,LC,BLINK off,blue background, fringed chars,
;          Half tone off, Int video mode, PAL norm (with 4Fsc interlaced), 
;          position (0,0), RAM address (0,0), luminance max for chars and 0
;          for background (fringes atc.), low chars 

InitOSD:
		mov		r7,#cmVideoRAMBatchClear;Internal RESET
		call	_send_byte
		mov		r6,#0
		mov		r7,#10
		lcall	_time				;delay 10 + 12/Fosc*288 [us, MHz]

		mov		a,#InitOSDControl	;Controls Disp out, LC osc, chr blink
		mov		OSDControl,a
		mov		r7,a
		call	_send_byte
		mov		r6,#high(500)
		mov		r7,#low(500)
		lcall	_time				;delay 50ms

		mov		a,#InitInternalVideoBkgrColor ;Blue background color
		mov		InternalVideoBkgrColor,a
		mov		r7,a
		call	_send_byte

		mov		a,#InitBkgrType		;Fringed
		mov		BkgrType,a
		mov		r7,a
		call	_send_byte

		clr		?BackGroundHalfTone?BIT
		mov		r7,#00111000b		;Half tone off
		call	_send_byte

		clr		?SelIntVideoMode?BIT
		mov		r7,#01000001b		;External, Osc on
		call	_send_byte

		mov		r7,#cmTVNormPAL		;PAL
		call	_send_byte

		mov		r7,#cmScanModeInterlace	;Interlace, 4Xfc (Fsc)
		call	_send_byte

		mov		r7,#cmSyncDetON		;Set synchro detection ON
		call	_send_byte

		mov		r6,#high(InitOSDPosition)
		mov		r7,#low(InitOSDPosition)
		call	_send_word
		
		mov		r6,#high(InitChar_BkgrLuminanceLevel)
		mov		r7,#low(InitChar_BkgrLuminanceLevel)
		call	_send_word

		mov		r6,#10001000b		;First line, first position
		mov		r7,#00000000b
		call	_send_word
		
		mov		r6,#10011000b		;sel char size
		mov		r7,#00000000b		;low in first line
		call	_send_word
		RET
;******************************************************************************
StartOSD:
		mov		a,OSDControl
		setb	acc.2
		setb	acc.3
		mov		OSDControl,a
		mov		r7,a
		call	_send_byte
		mov		r7,#80
		clr		a
wait_for_osc_stable:
		djnz	acc,$
		djnz	r7,wait_for_osc_stable
		ret
;******************************************************************************
ClearOSD:
		mov		r7,#cmVideoRAMBatchClear;Internal RESET
		call	_send_byte
		mov		r6,#0
		mov		r7,#10
		ljmp	_time				;delay 10 + 12/Fosc*288 [us, MHz]
;******************************************************************************
StopOSD:
		mov		a,OSDControl
		clr		acc.2
		clr		acc.3
		mov		OSDControl,a
		mov		r7,a
		jmp		_send_byte
;******************************************************************************
OSDOn:	mov		a,OSDControl
		setb	acc.3
		mov		OSDControl,a
		mov		r7,a
		jmp		_send_byte
;******************************************************************************
OSDOff:	mov		a,OSDControl
		clr		acc.3
		mov		OSDControl,a
		mov		r7,a
		jmp		_send_byte
;******************************************************************************
_OSDBlink:
		anl		OSDControl,#11111100b
		mov		a,r7
		anl		a,#3
		orl		a,OSDControl
		mov		OSDControl,a
		mov		r7,a
		jmp		_send_byte
;******************************************************************************
_SelBkgrColor:
		mov		a,r7
		mov		InternalVideoBkgrColor,a
		jmp		_send_byte
;******************************************************************************
_SelBkgrType:
		mov		a,r7
		mov		BkgrType,a
		jmp		_send_byte
;******************************************************************************
BackGroundHalfTone:
		MOV		C,?BackGroundHalfTone?BIT
		MOV		A,#00111000B
		MOV		ACC.2,C
		MOV		R7,A
		jmp		_send_byte
;******************************************************************************
SelIntVideoMode:
		MOV		C,?SelIntVideoMode?BIT
		MOV		A,#01000001B
		MOV		ACC.2,C
		MOV		R7,A
		jmp		_send_byte
;******************************************************************************
_SetOSDPosition:
		mov		a,r7
		anl		a,#00011111b
		mov		OSDPosition,a		;X - coordinate (Horizontal)
		mov		a,r5
		anl		a,#00011111b
		mov		OSDPosition+1,a		;Y - coordinate (Vertical)
		swap	a
		rl	a
		mov		r6,a
		anl		a,#11100000b
		orl		a,OSDPosition
		mov		r7,a
		mov		a,r6
		anl		a,#00000011b
		orl		a,#10000000b
		mov		r6,a
		ajmp	_send_word
;******************************************************************************
_SetRAMAddress:
		mov		a,r7
		anl		a,#00011111b
		mov		RAMAddress,a		;X - coordinate (Column)
		mov		a,r5
		anl		a,#00001111b
		mov		RAMAddress+1,a		;Y - coordinate (Row)
		swap	a
		clr		c
		rlc		a
		anl		a,#11100000b
		orl		a,RAMAddress
		mov		r7,a
		mov		a,#10001000b
		mov		acc.0,c
		mov		r6,a
		ajmp	_send_word
;******************************************************************************
;void DispOSDChar(byte Char, byte BlinkAttr);
_DispOSDChar:
		mov		a,r5				;Blink attr
		RLC		A					;Blink attribute --> CY
		mov		a,#11000000b
		mov		acc.1,c
		mov		r6,a
		mov		a,r7
		call	xlat
		mov		r7,a
		ajmp	_send_word
;******************************************************************************
;void DispUnxlatedOSDChar(byte Char, byte BlinkAttr);
_DispUnxlatedOSDChar:
		mov		a,r5				;Blink attr
		RLC		A					;Blink attribute --> CY
		mov		a,#11000000b
		mov		acc.1,c
		mov		r6,a
		ajmp	_send_word
;******************************************************************************
;DispOSDLine(word ColumnAndRow, byte SizeAndBlinkAttr, char * String);
_DispOSDLine:
		MOV		A,R6				;Column
		ANL		A,#00011111B
		MOV		R6,A
		MOV		A,R7				;Row
		MOV		R0,A				;Store it
		ANL		A,#00001111B
		SWAP	A
		CLR		C
		RLC		A
		ORL		A,R6
		MOV		R7,A
		MOV		A,#10001000B		;cmRAMAddress
		MOV		ACC.0,C
		MOV		R6,A
		ACALL	_SEND_WORD
		
		MOV		R6,#10011000B
		MOV		A,R0				;Stored Row
		ANL		A,#00001111B
		MOV		R7,A
		MOV		A,R5				;Size
		ANL		A,#3
		SWAP	A
		RL	A
		RL	A
		ORL		A,R7
		MOV		R7,A
		ACALL	_SEND_WORD
		MOV		A,R5
		MOV		R7,A
		
;DispOSDString(byte BlinkAttr, char * String);
_DispOSDString:
		MOV		A,R7
		RLC		A					;Blink attribute
		MOV		A,#11000000B
		MOV		ACC.1,C
		CLR		SCLK
		CLR		SDATA				;Don't generate I2C START condition
		CLR		ENABLE
		CALL	SEND_BYTE
_WriteOSDBlock:						;Only local procedure, not called
		MOV		DPTR,#0
_WriteOSDBlockLoop:
		PUSH	DPL
		PUSH	DPH
		LCALL	?C_CLDOPTR
		POP		DPH
		POP		DPL
		JZ	_WriteOSDBlockEnd
		CJNE	A,#' ',$+3
		JC	_WriteOSDBlockEnd
		CALL	XLAT
		CALL	SEND_BYTE
		INC		DPL					;Counts also number of chars per line
		SJMP	_WriteOSDBlockLoop
_WriteOSDBlockEnd:
		SETB	ENABLE
		SETB	SDATA
		SETB	SCLK				;Don't generate I2C STOP condition
		mov		a,dpl				;Offset of last character displayed
		MOV		R7,A
		RET
;******************************************************************************
;
; Name: XLAT
;
; Abstract: This routine translates input character in national font
;           to the internal display representation stored in CG RAM.
;
; Subroutines accessed: None
;
; Variables used: ACC, R7
;
; STACK requiremend: None
;
;****************************************************************************
XLAT:	ADD		A,#(XLAT_TBL-$-3)
		MOVC	A,@A+PC
		RET
XLAT_TBL:
%if (%OSDPart EQ 6454) then (
DB  00H, 01H, 02H, 03H, 04H, 05H, 06H, 07H, 08H, 09H, 0AH, 0BH, 0CH, 0DH, 0EH, 0FH
DB  10H, 11H, 12H, 13H, 14H, 15H, 16H, 17H, 18H, 19H, 1AH, 1BH, 1CH, 1DH, 1EH, 1FH
;New10H,071H, 63H, 6DH, 6FH, 6CH, 6EH, 63H, 78H, 79H, 7AH, 7BH, 7CH, 1FH, 7DH, 30H
DB 0FEH,0E0H, 63H, 6DH, 6FH, 6CH, 6EH, 63H, 78H, 79H, 7AH, 7BH, 7CH, 1FH,0FEH, 30H
;   ' '  '!'  '"'  '#'  '$'  '%'  '&'  '''  '('  ')'  '*'  '+'  ','  '-'  '.'  '/'
;New00H, 01H, 02H, 03H, 04H, 05H, 06H, 07H, 08H, 09H, 0AH, 0BH, 0CH, 0DH, 0EH, 0FH
DB  00H, 01H, 02H, 03H, 04H, 05H, 06H, 07H, 08H, 09H, 0AH, 0BH, 0CH, 0DH, 0EH, 0FH
;   '0'  '1'  '2'  '3'  '4'  '5'  '6'  '7'  '8'  '9'  ':'  ';'  '<'  '='  '>'  '?'
;New67H, 11H, 12H, 13H, 14H, 15H, 16H, 17H, 18H, 19H, 1AH, 1BH, 1CH, 1DH, 1EH, 00H
DB  80H, 0AH, 0BH, 0CH, 0DH, 0EH, 0FH, 10H, 11H, 12H, 13H, 14H, 15H, 16H, 17H, 00H
;   '@'  'A'  'B'  'C'  'D'  'E'  'F'  'G'  'H'  'I'  'J'  'K'  'L'  'M'  'N'  'O' 
;New20H, 21H, 22H, 23H, 24H, 25H, 26H, 27H, 28H, 29H, 2AH, 10H, 10H, 10H, 10H, 10H
DB  19H, 1AH, 1BH, 1CH, 1DH, 1EH, 1FH, 20H, 21H, 22H, 23H,0FEH,0FEH,0FEH,0FEH,0E8H
;   'P'  'Q'  'R'  'S'  'T'  'U'  'V'  'W'  'X'  'Y'  'Z'  '['  '\'  ']'  '^'  '_'   
;New10H, 31H, 32H, 33H, 34H, 35H, 36H, 37H, 38H, 39H, 3AH, 3BH, 3CH, 3DH, 3EH, 3FH
DB  80H, 0AH, 0BH, 0CH, 0DH, 0EH, 0FH, 10H, 11H, 12H, 13H, 14H, 15H, 16H, 17H, 00H
;   '@'  'a'  'b'  'c'  'd'  'e'  'f'  'g'  'h'  'i'  'j'  'k'  'l'  'm'  'n'  'O' 
;New40H, 41H, 42H, 43H, 44H, 45H, 46H, 47H, 48H, 49H, 4AH, 78H, 30H, 79H, 68H, 1FH
DB  19H, 1AH, 1BH, 1CH, 1DH, 1EH, 1FH, 20H, 21H, 22H, 23H,0FEH,0FEH,0FEH,0FEH,0E8H
;   'p'  'q'  'r'  's'  't'  'u'  'v'  'w'  'x'  'y'  'z'  '['  '\'  ']'  '^'  '_'   
) fi
%if (%OSDPart EQ 6458) then (
DB  7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH
DB  7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH
DB  10H, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 78H, 7BH, 6CH, 7EH, 0FH, 0DH, 0EH, 6DH
;   ' '  '!'  '"'  '#'  '$'  '%'  '&'  '''  '('  ')'  '*'  '+'  ','  '-'  '.'  '/'
DB  00H, 01H, 02H, 03H, 04H, 05H, 06H, 07H, 08H, 09H, 0AH, 6BH, 0BH, 7EH, 0CH, 50H
;   '0'  '1'  '2'  '3'  '4'  '5'  '6'  '7'  '8'  '9'  ':'  ';'  '<'  '='  '>'  '?'
DB  7EH, 11H, 12H, 13H, 14H, 15H, 16H, 17H, 18H, 19H, 1AH, 1BH, 1CH, 1DH, 1EH, 00H
;   '@'  'A'  'B'  'C'  'D'  'E'  'F'  'G'  'H'  'I'  'J'  'K'  'L'  'M'  'N'  'O'
DB  20H, 21H, 22H, 23H, 24H, 25H, 26H, 27H, 28H, 29H, 2AH, 7EH, 7EH, 7EH, 7EH, 7EH
;   'P'  'Q'  'R'  'S'  'T'  'U'  'V'  'W'  'X'  'Y'  'Z'  '['  '\'  ']'  '^'  '_'
DB  7EH, 51H, 52H, 53H, 54H, 55H, 56H, 57H, 58H, 59H, 5AH, 5BH, 5CH, 5DH, 5EH, 5FH
;   '`'  'a'  'b'  'c'  'd'  'e'  'f'  'g'  'h'  'i'  'j'  'k'  'l'  'm'  'n'  'o'
DB  60H, 61H, 62H, 63H, 64H, 65H, 66H, 67H, 68H, 69H, 6AH, 6BH, 6CH, 6DH, 6EH, 6FH
;   'p'  'q'  'r'  's'  't'  'u'  'v'  'w'  'x'  'y'  'z'  '{'  '|'  '}'  '~'  ''
;Following part translates national codes from Latin2 and Kamenicky to ASCII
DB  13H, 65H, 55H, 51H, 51H, 51H, 51H, 53H, 55H, 55H, 55H, 59H, 59H, 59H, 11H, 11H
DB  15H, 6AH, 2AH, 5FH, 5FH, 5FH, 65H, 65H, 69H, 00H, 25H, 23H, 1CH, 29H, 22H, 64H
DB  51H, 59H, 5FH, 65H, 11H, 51H, 2AH, 6AH, 15H, 55H, 7EH, 2AH, 13H, 63H, 7EH, 7EH
DB  7EH, 7EH, 7EH, 7EH, 7EH, 11H, 11H, 15H, 23H, 7EH, 7EH, 7EH, 7EH, 2AH, 6AH, 7EH
DB  7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 11H, 51H, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH
DB  54H, 14H, 14H, 15H, 54H, 1EH, 19H, 7EH, 55H, 7EH, 7EH, 7EH, 7EH, 7EH, 25H, 7EH
DB  00H, 52H, 00H, 1EH, 5EH, 5EH, 23H, 63H, 22H, 25H, 62H, 65H, 69H, 29H, 64H, 7EH
DB  7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 7EH, 00H, 22H, 62H, 7EH, 7EH
) fi
END 
